unit Main;

interface

uses DelphiIEBand, Classes, DelphiIEBandFrm, SomeDelphiIEBandFrm;

type
  TSomeDelphiBandFactory=class(TDelphiBandFactory)
  protected
    function GetCLSID:string; override;
    function GetCaption:string; override;
    function GetBandType:string; override;
    function IsToolband:boolean; override;
  end;
  
  TSomeDelphiBand=class(TDelphiBand)
  protected
{    procedure ContextMenuFired(AIndex:integer); override; only needed for deskbands (taskbar toolbars)
    function GetContextMenu:TStrings; override;}
    function GetCLSID:string; override;
    function GetCaption:string; override;
    function GetBandType:string; override;
    function IsToolband:boolean; override;
    function IsFixed:boolean; override;
    function GetFormClass:TDelphiIEBandFormClass; override;
  end;

const
  // the following 5 constants must be duplicated for each band
  C1_BandClass:TDelphiBandClass=TSomeDelphiBand;// this is the bands class
  C1_FormClass:TDelphiIEBandFormClass=TSomeDelphiIEBandForm;// the form class
  C1_CLSID='{1D26ED9A-45EE-4682-BD91-3AE6C44876E7}';// this must be generated unique per band. use ctrl+shift+g
  C1_Caption='IE Toolbar Demo';// this is displayed in IE
  C1_BandType=DeskBand;// this is the type
  C1_IsToolBand=true;// true if it's a tool band
  C1_IsFixed=true;// true if the form does not require sizeing

implementation

uses ComServ, SysUtils, Dialogs, ComObj;

{ TSomeDelphiBandFactory }

function TSomeDelphiBandFactory.GetBandType: string;
begin
  result:=C1_BandType;
end;

function TSomeDelphiBandFactory.GetCaption: string;
begin
  result:=C1_Caption;
end;

function TSomeDelphiBandFactory.GetCLSID: string;
begin
  result:=C1_CLSID;
end;

function TSomeDelphiBandFactory.IsToolband: boolean;
begin
  result:=C1_IsToolBand;
end;

{ TSomeDelphiBand }

{procedure TSomeDelphiBand.ContextMenuFired(AIndex: integer);
var x:olevariant;
begin
  case aIndex of
    0: UpdateBandInfo;
    1: begin
         x:=0;
         IE.Navigate('http://www.google.com', X, X, X, X);
       end;
    2: Showmessage('IE toolbar demo derived from bsalsa demo.');
  end;
end;

function TSomeDelphiBand.GetContextMenu: TStrings;
begin
  result:=TStringList.Create;
  result.add('Update Bandinfo');
  result.add('Navigate to google.com');
  result.add('Show a message');
end;}

function TSomeDelphiBand.GetCLSID: string;
begin
  result:=C1_CLSID;
end;

function TSomeDelphiBand.GetCaption: string;
begin
  result:=C1_Caption;
end;

function TSomeDelphiBand.GetBandType: string;
begin
  result:=C1_BandType;
end;

function TSomeDelphiBand.IsToolband: boolean;
begin
  result:=C1_IsToolBand;
end;

function TSomeDelphiBand.IsFixed: boolean;
begin
  result:=C1_IsFixed;
end;

function TSomeDelphiBand.GetFormClass: TDelphiIEBandFormClass;
begin
  result:=C1_FormClass;
end;

initialization
  TSomeDelphiBandFactory.Create(ComServer, C1_BandClass, StringToGUID(C1_CLSID), '', C1_Caption, ciMultiInstance);// note: shouldn't this be tmApartment? as suggested in AddKeys

end.
